-- Freeslots --

rawset(_G, "DRBUPGRADED", 0) -- Determines whether or not the Dummy Ring Bomb is upgraded

freeslot("S_DUMMYBOMB1", "S_DUMMYBOMB_COST", "S_DUMMYBOMB_CONT", "S_DBOMB_SOUND", "S_DBOMB_EXPL1", "S_DBOMB_EXPL2", "S_DBOMB_EXPL3", "S_DBOMB_EXPL4", "S_DBOMB_DIE", 
"S_DUMMYRING", "S_DRING_DIE", "MT_DUMMYBOMB1", "MT_DUMMYRING", "S_DUMMYBOMB2", "MT_DUMMYBOMB2", "S_PLAY_THROW", "S_PLAY_THROWFIN", 
"sfx_hyah", "sfx_hupp")

states[S_DUMMYBOMB1] = {
	sprite = SPR_TVRI,
	frame = A,
	tics = 1,
	action = A_LobShot,
	nextstate = S_DUMMYBOMB_COST
}

states[S_DUMMYBOMB_COST] = {
	sprite = SPR_TVRI,
	frame = A,
	tics = 1,
	action = A_RingBox,
	nextstate = S_DUMMYBOMB_CONT
}

states[S_DUMMYBOMB_CONT] = {
	sprite = SPR_TVRI,
	frame = A,
	tics = -1
}

states[S_DBOMB_SOUND] = {
	sprite = SPR_TVRI,
	frame = A,
	tics = 1,
	action = A_Pain,
	nextstate = S_DBOMB_EXPL1
}

states[S_DBOMB_EXPL1] = {
	sprite = SPR_TVRI,
	frame = A,
	tics = 1,
	action = A_Explode,
	nextstate = S_DBOMB_EXPL2
}

states[S_DBOMB_EXPL2] = {
	sprite = SPR_TVRI,
	frame = B,
	tics = 1,
	action = A_NapalmScatter,
	var1 = MT_DUMMYRING+(12<<16),
	var2 = 200+(40<<16),
	nextstate = S_DBOMB_EXPL3
}

states[S_DBOMB_EXPL3] = {
	sprite = SPR_TVRI,
	frame = A,
	tics = 1,
	action = A_NapalmScatter,
	var1 = MT_DUMMYRING+(8<<16),
	var2 = 100+(32<<16),
	nextstate = S_DBOMB_EXPL4
}

states[S_DBOMB_EXPL4] = {
	sprite = SPR_TVRI,
	frame = A,
	tics = 1,
	action = A_NapalmScatter,
	var1 = MT_DUMMYRING+(1<<16),
	var2 = 24<<16,
	nextstate = S_DBOMB_DIE
}

states[S_DBOMB_DIE] = {
	sprite = SPR_NULL,
	frame = A,
	tics = 1,
	action = A_Scream,
	nextstate = S_NULL
}

states[S_DUMMYRING] = {
	sprite = SPR_RING,
	frame = A,
	tics = 100,
	nextstate = S_DRING_DIE
}

states[S_DRING_DIE] = {
	sprite = SPR_NULL,
	frame = A,
	tics = 1,
	nextstate = S_XPLD1
}

mobjinfo[MT_DUMMYBOMB1] = {
	spawnstate = S_DUMMYBOMB1,
	spawnhealth = 1,
	height = 40*FRACUNIT,
	radius = 18*FRACUNIT,
	speed = 50*FRACUNIT,
	deathstate = S_DBOMB_SOUND,
	deathsound = sfx_pop,
	painsound = sfx_altow1,
	flags = MF_NOBLOCKMAP|MF_MISSILE
}

mobjinfo[MT_DUMMYRING] = {
	spawnstate = S_DUMMYRING,
	seesound = sfx_altow1,
	spawnhealth = 1,
	height = 24*FRACUNIT,
	radius = 16*FRACUNIT,
	speed = 38*FRACUNIT,
	deathstate = S_DRING_DIE,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_GRENADEBOUNCE
}

states[S_DUMMYBOMB2] = {
	sprite = SPR_TVRI,
	frame = A,
	tics = 1,
	action = A_FireShot,
	nextstate = S_DUMMYBOMB_COST
}

mobjinfo[MT_DUMMYBOMB2] = {
	spawnstate = S_DUMMYBOMB2,
	spawnhealth = 1,
	height = 40*FRACUNIT,
	radius = 18*FRACUNIT,
	speed = 50*FRACUNIT,
	deathstate = S_DBOMB_SOUND,
	deathsound = sfx_pop,
	painsound = sfx_altow1,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY
}

states[S_PLAY_THROW] = {
	sprite = SPR_PLAY,
	frame = SPR2_EDGE|FF_SPR2ENDSTATE,
	tics = 2,
	action = A_ForceStop,
	var1 = S_PLAY_THROWFIN,
	nextstate = S_PLAY_THROW
}

states[S_PLAY_THROWFIN] = {
	sprite = SPR_PLAY,
	frame = SPR2_EDGE,
	tics = 15,
	action = A_ForceStop,
	var1 = S_PLAY_STND,
	nextstate = S_PLAY_STND
}

S_sfx[sfx_hyah] = {
	singular = false,
	priority = 255,
	flags = 0,
	caption = "Hyah!"
}

S_sfx[sfx_hupp] = {
	singular = false,
	priority = 255,
	flags = 0,
	caption = "Hupp!"
}